<?php

// Fonctions accessibles  partir de toutes les pages

function f_all_items ($file_name) {
// fonction qui renvoie la totalit des items pour un fichier de donnes
// dans un tableau d'items contenant tous les champs

	require ("config.inc.php");
	
	$file_complet = $GLOBALS["files_dir"].$file_name;
	$file_open = fopen ($file_complet, "r");
	
	// boucle pour crer le tableau d'items avec les bonnes valeurs pour chaque champ :
	// theme, title, url, img, desc_fr, desc_en
	
	// i sert  compter le nombre d'items.
	$i = 1;
	$theme="defaut";
	while(!feof($file_open)){
		$ligne = fgetcsv($file_open,"1024","=");
		if ($ligne[0] == $var_theme) {
			// on a trouv le thme
			$theme=$ligne[1];
		} else if ($ligne[0] == $var_title) {
			if($all_items[$i][$var_title] != "")
			$i++;
			$all_items[$i][$var_title] = $ligne[1];
		} else if ($ligne[0] == $var_img) {
			$all_items[$i][$var_img] = basename($ligne[1]);
		} else if ($ligne[0] == $var_url) {
			$all_items[$i][$var_url] = $ligne[1];
			$all_items[$i][$var_theme] = $theme;
		} else if ($ligne[0] == $var_desc) {
			$desc = explode("!",$ligne[1]);
			$all_items[$i][$var_desc][$desc[0]] = $desc[1];
			
		}
	}

	fclose($file_open);

	// On retourne le tableau de tous les items
	return $all_items;
}

function f_list_themes ($file_name) {
	// fonction qui renvoie la liste des themes pour un groupe de liens donn
	// sous forme de tableau

	require ("config.inc.php");
	$tab=f_all_items ($file_name);
	$array_sites = array();
	if ($tab<>"") {
		foreach($tab as $cle => $val) {
			if(!in_array($val[$var_theme],$array_sites))
			$array_sites[]=$val[$var_theme];
		}
		return $array_sites;
	} else return "";
}

function f_nb_items_theme ($all_items, $theme) {
	// fonction qui renvoie le nombre d'items contenu dans un tableau de liens appartenant au thme indiqu

	require ("config.inc.php");
	$nb_items="0";
	for ($t="0"; $t <= count($all_items); $t++) {
		if ($all_items[$t][$var_theme]==$theme) {$nb_items++;}
	}
	return $nb_items;
}

function f_rec_item ($file_name,$rang,$new_item) {
	// fonction qui enregistre dans le fichier pass en paramtres l'item $new_item au rang $rang.
	// l'item est insr au rang indiqu !!!
	
	require ("config.inc.php");
	$all_items=f_all_items ($file_name);

	// on insre l'item au bon endroit 
	$nb_all_items=count($all_items);
	
	// tableau qui contiendra tous les items avec celui  insrer
	$nouv_all_items = array();
	
	if ($nb_all_items>=1) {
		$j=1;
		for ($i=1;$i<=$nb_all_items+1;$i++) {
			if ($i==$rang) {
				$nouv_all_items[$i]=$new_item;
			} else {
				$nouv_all_items[$i]=$all_items[$j];
				$j++;
			}
		}
	} else {

		// cas d'un fichier initialement vide
		$nouv_all_items[1] = $new_item;
	}
	
	// on enregistre dans le nouveau fichier
	f_rec_all_items($file_name,$nouv_all_items);
}


function f_rec_all_items($file_name,$all_items) {
// fonction qui enregistre dans le fichier la totalit des items passs en paramtres
// dans le bon fichier en l'crasant.
// les themes sont tris et enregistrs ensemble.

	require ("config.inc.php");
	$file_complet = $files_dir.$file_name;
	$file_open = fopen ($file_complet, "w+");
	fseek($file_open,0);
	
	$theme_en_cours="";
	
	// on compte le nombre de thmes du tableau

	$array_sites = array();
	if ($all_items<>"") {
		foreach($all_items as $cle => $val) {
			if(!in_array($val[$var_theme],$array_sites))
			$array_sites[]=$val[$var_theme];
		}
	}
	$nb_themes=count($array_sites);
	
	// on parcourt le tableau pour chaque theme
	for ($theme=0;$theme<$nb_themes;$theme++) {

		$theme_en_cours=$array_sites[$theme];
		$item_theme_rec= $var_theme.$var_separ.$array_sites[$theme]."\n";

		// on ajoute le theme en debut de fichier
		if ($item_theme_rec<>"listeapplications") {
			fputs($file_open,$item_theme_rec);
		}
		
		// il faut ensuite n'enregistrer que les liens de ce theme

		$i="1"; // sert  compter les items qui ont le bon theme

		// imax = nombre de liens du theme
		$imax=f_nb_items_theme($all_items,$theme_en_cours);
		$rang="1"; // rang va parcourir tous les liens et permettre de choisir les bons.

		while ($i<=$imax) {
			if ($all_items[$rang][$var_theme]==$theme_en_cours) {

				// on rajoute une entre de lien
				$item_title_rec= $var_title.$var_separ.$all_items[$rang][$var_title]."\n";
				$item_img_rec= $var_img.$var_separ.$all_items[$rang][$var_img]."\n";
				$item_url_rec= $var_url.$var_separ.$all_items[$rang][$var_url]."\n";
				$item_desc_fr_rec= $var_desc.$var_separ.$var_desc_fr.$var_desc_separ.$all_items[$rang][$var_desc][$var_desc_fr]."\n";
				$item_desc_en_rec= $var_desc.$var_separ.$var_desc_en.$var_desc_separ.$all_items[$rang][$var_desc][$var_desc_en]."\n";
				fputs($file_open,$item_title_rec);
				fputs($file_open,$item_img_rec);
				fputs($file_open,$item_url_rec);
				fputs($file_open,$item_desc_fr_rec);
				fputs($file_open,$item_desc_en_rec);
				fputs($file_open,"\n"); // on saute une ligne
				// on a trouv un item et on rajoute pour atteindre le nombre maxi de liens de ce theme
				$i++;
			}
			$rang++;
		}
	// Et on passe au theme suivant
	}
	
	fclose($file_open);
}


?>
